
/*

Hudson junit style output

<testsuite errors="0" failures="1" hostname="localhost" name="editInvestigation.do" tests="1" time="0" timestamp="0">
	<testcase classname="editInvestigation.do" name="editInvestigation.do" time="0">
		<failure message="W3C HTML Validation Failed, 82 errors ">
			<![CDATA[
				see <a href="foo.html">Detailed Results</a>
			]]>
		</failure>
	</testcase>
</testsuite>

*/

function xpcshell_output_xunit() {
	this.testno = 0;
	this.suite_started = false;
}

xpcshell_output_xunit.prototype._file = function (stack) {
	if (typeof stack === 'string') {
		return stack;
	} else {
		return stack.filename + ':' + stack.lineNumber;
	}
};

xpcshell_output_xunit.prototype.start_suite = function(stack) {
	if (! this.suite_started) {
		// done in runxpcshelltests.py
		// dump('<testsuite name="' + this._file(stack) + "\">\n");
		this.suite_started = true;
	}
};
xpcshell_output_xunit.prototype.finish_suite = function(stack) {
	if (this.suite_started) {
		// done in runxpcshelltests.py
		// dump("</testsuite>\n");
		this.suite_started = false;
	}
};

xpcshell_output_xunit.prototype._clean_msg = function(str) {
	return "<![CDATA[\n" + str + "]]>";
};

xpcshell_output_xunit.prototype.info = function(stack, msg) {
	this.start_suite(stack);
	dump('<!-- ' + this._file(stack) + "\n");
	dump(msg);
	dump("\n-->\n");
};

xpcshell_output_xunit.prototype._case = function(stack, type, msg) {
	this.start_suite(stack);
	this.testno++;

	var file, lineno;
	if (typeof stack === 'string') {
		file = stack;
		lineno = 0;
	} else {
		file = stack.filename;
		lineno = stack.lineNumber;
	}
	var basename = file.replace(/^.*[\/\\]/g, '');
	dump('<testcase classname="' + basename + '" name="' + this.testno + '" time="0"' + ">\n");
    dump('    <' + type + ' message="' + file + '" line="' + lineno + '">' + this._clean_msg(msg) + '</' + type + ">\n");
    dump("</testcase>\n");
}

xpcshell_output_xunit.prototype.pass = function(stack, msg) {
	this._case(stack, 'info', msg);
};

xpcshell_output_xunit.prototype.fail = function(stack, msg) {
	this._case(stack, 'failure', msg);
};

xpcshell_output_xunit.prototype.summary = function(stack, truePassedChecks, internalPassedChecks, failedChecks) {
	var msg = (truePassedChecks + failedChecks > 0)
		? truePassedChecks + " (+" + internalPassedChecks + " internal) check(s) passed. " + failedChecks + ' failed.'
		: "No user tests supplied! (" + internalPassedChecks + " internal checks passed)";

	this.info(stack, msg);
	this.finish_suite(stack);
};

